#!/bin/env /bin/bash

set -eu

if [ $# -ne 1 ]; then
	exit 2;
fi

source /etc/kguard/interventions/base_funcs.sh

timeout_value=$(getTimeout)

TIMEOUT=
if [ $timeout_value -ne -1 ]; then
    TIMEOUT="timeout ${timeout_value}s"
fi

nft add table ip filter
nft add set ip filter kguard_blacklists { type ipv4_addr \; flags timeout \; }
nft add element ip filter kguard_blacklists { $1 $TIMEOUT }
nft add chain ip filter input { type filter hook input priority 0\; }

if ! nft list chain ip filter input | grep -q 'ip saddr @kguard_blacklists drop'; then
    nft add rule ip filter input ip saddr @kguard_blacklists drop
fi
